﻿------------------------------
--      Are you local?      --
------------------------------

local boss = AceLibrary("Babble-Boss-2.2")["Sulfuron Harbinger"]
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Sulfuron",

	inspire = "Inpire Gain Alert",
	inspire_desc = "Warn when Sulfuron gains Inspire",

	heal = "Heal Alert",
	heal_desc = "Warn when a Flamewaker Priest starts healing",

	inspire_trigger = "%s gains Inspire",
	inpire_message = "Sulfuron gains Inspire!",
	inspire_bar = "Inspire",

	heal_trigger = "begins to cast Dark Mending",
	heal_message = "A Flamewaker Priest is healing!",
	heal_bar = "Dark Mending",
} end)

L:RegisterTranslations("frFR", function() return {
	inspire = "Alerte Inspirer",
	inspire_desc = "Pr\195\169viens quand le Messager de Sulfuron gagne Inspirer.",

	heal = "Alerte Soins",
	heal_desc = "Pr\195\169viens quand un Pr\195\170tre Attise-flammes commence \195\160 lancer un soin.",

	inspire_trigger = "%s gagne Inspirer",
	inpire_message = "Sulfuron gagne Inspirer !",
	inspire_bar = "Inspirer",

	heal_trigger = "commence \195\160 lancer Gu\195\169rison t\195\169n\195\169breuse",
	heal_message = "Un Pr\195\170tre Attise-flammes lance un soin !",
	heal_bar = "Gu\195\169rison t\195\169n\195\169breuse",
} end)

L:RegisterTranslations("zhTW", function() return {
	cmd = "薩弗隆先驅者",

	inspire = "Inpire Gain Alert",
	inspire_desc = "Warn when Sulfuron gains Inspire",

	heal = "治療警報",
	heal_desc = "當火焰行者施放黑暗治療時發出警報",

	inspire_trigger = "%s gains Inspire",
	inpire_message = "Sulfuron gains Inspire!",
	inspire_bar = "Inspire",

	heal_trigger = "begins to cast Dark Mending",
	heal_message = "A Flamewaker Priest is healing!",
	heal_bar = "黑暗治療",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.zonename = AceLibrary("Babble-Zone-2.2")["Molten Core"]
mod.enabletrigger = boss
mod.toggleoptions = {"inspire", -1, "heal", "bosskill"}
mod.revision = tonumber(string.sub("$Revision: 33125 $", 12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS")
	self:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF")
	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH", "GenericBossDeath")
	self:RegisterEvent("BigWigs_RecvSync")
	self:TriggerEvent("BigWigs_ThrottleSync", "SulfuronInsp", 5)
	self:TriggerEvent("BigWigs_ThrottleSync", "SulfuronHeal", 2.5)
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS(msg)
	if (msg:find(L["inspire_trigger"])) then
		self:Sync("SulfuronInsp")
	end
end

function mod:CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF(msg)
	if (msg:find(L["heal_trigger"])) then
		self:Sync("SulfuronHeal")
	end
end

function mod:BigWigs_RecvSync(sync)
	if (sync == "SulfuronInsp" and self.db.profile.inspire) then
		self:Message(L["inpire_message"], "Attention")
		self:Bar(L["inspire_bar"], 10, "Ability_Warrior_BattleShout")
	elseif (sync == "SulfuronHeal" and self.db.profile.heal) then
		self:Message(L["heal_message"], "Important")
		self:Bar(L["heal_bar"], 2, "Spell_Shadow_ChillTouch")
	end
end
